
#ifndef __EZDEFINES_H
#define __EZDEFINES_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>

#if defined(TM4C123GH6PM)
    #include "TM4C123GH6PM.h"
#elif defined(TM4C1294NCPDT)
    #include "TM4C1294NCPDT.h"
#endif

/* helper macros */
#define MHZ(x) ((uint32_t)(x*1000000.0 + .5))
#define GHZ(x) ((uint32_t)(x*1000000000.0 + .5))


#ifndef _PIN0
    #define _PIN0   0x01
#endif
#ifndef _PIN1
    #define _PIN1   0x02
#endif
#ifndef _PIN2
    #define _PIN2   0x04
#endif
#ifndef _PIN3
    #define _PIN3   0x08
#endif
#ifndef _PIN4
    #define _PIN4   0x10
#endif
#ifndef _PIN5
    #define _PIN5   0x20
#endif
#ifndef _PIN6
    #define _PIN6   0x40
#endif
#ifndef _PIN7
    #define _PIN7   0x80
#endif


#ifndef _BIT0
    #define _BIT0   0x01
#endif
#ifndef _BIT1
    #define _BIT1   0x02
#endif
#ifndef _BIT2
    #define _BIT2   0x04
#endif
#ifndef _BIT3
    #define _BIT3   0x08
#endif
#ifndef _BIT4
    #define _BIT4   0x10
#endif
#ifndef _BIT5
    #define _BIT5   0x20
#endif
#ifndef _BIT6
    #define _BIT6   0x40
#endif
#ifndef _BIT7
    #define _BIT7   0x80
#endif

#ifndef _PORTA
    #define _PORTA  0x0001
#endif
#ifndef _PORTB
    #define _PORTB  0x0002
#endif
#ifndef _PORTC
    #define _PORTC  0x0004
#endif
#ifndef _PORTD
    #define _PORTD  0x0008
#endif
#ifndef _PORTE
    #define _PORTE  0x0010
#endif
#ifndef _PORTF
    #define _PORTF  0x0020
#endif

#ifndef _PORTG
    #define _PORTG  0x0040
#endif
#ifndef _PORTH
    #define _PORTH  0x0080
#endif
#ifndef _PORTJ
    #define _PORTJ  0x0100
#endif
#ifndef _PORTK
    #define _PORTK  0x0200
#endif
#ifndef _PORTL
    #define _PORTL  0x0400
#endif
#ifndef _PORTM
    #define _PORTM  0x0800
#endif
#ifndef _PORTN
    #define _PORTN  0x1000
#endif
#ifndef _PORTP
    #define _PORTP  0x2000
#endif
#ifndef _PORTQ
    #define _PORTQ  0x4000
#endif


#if defined(TM4C123GH6PM)
    #include "TM4C123GH6PM.H"
    typedef GPIOA_Type      GPIO_Port;
    typedef GPIOA_Type*     PGPIO_Port;

#elif defined(TM4C1294NCPDT)
    #include "TM4C1294NCPDT.h"
    typedef GPIOA_AHB_Type  GPIO_Port;
    typedef GPIOA_AHB_Type* PGPIO_Port;
#else
    #error "The Device NOT specified"
#endif


PGPIO_Port  GetGPIOAddress(uint32_t port);


#endif
